image:
  name: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

variables:
  TF_ROOT: ${CI_PROJECT_DIR}/terraform  # The relative path to the root directory of the Terraform project
  TF_STATE_NAME: default  # The name of the state file used by the GitLab Managed Terraform state backend
  #TF_VAR_aws_access_key: ${AWS_ACCESS_KEY_ID}
  TF_VAR_aws_region: us-east-1
  #TF_VAR_aws_sec_key: ${AWS_SECRET_ACCESS_KEY}

cache:
  key: "${TF_ROOT}"
  paths:
    - ${TF_ROOT}/.terraform/

stages:
  - prepare
  - build
  - deploy
  - destroy

validate:
  stage: prepare
  script:
    - gitlab-terraform init
    - gitlab-terraform validate

plan:
  stage: build
  before_script:
  - cd ${TF_ROOT}
  - apk update && apk --no-cache add py3-pip && apk --no-cache add zip
  - pip install awscli
  - aws configure set default.region ${TF_VAR_aws_region} && aws configure set aws_access_key_id ${TF_VAR_aws_access_key} && aws configure set aws_secret_access_key ${TF_VAR_aws_sec_key} | sh
  script:
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  resource_group: ${TF_STATE_NAME}
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

# Separate apply job for manual launching Terraform 
apply:
  stage: deploy
  before_script:
  - cd ${TF_ROOT}
  - apk update && apk --no-cache add py3-pip && apk --no-cache add zip
  - pip install awscli
  - aws configure set default.region ${TF_VAR_aws_region} && aws configure set aws_access_key_id ${TF_VAR_aws_access_key} && aws configure set aws_secret_access_key ${TF_VAR_aws_sec_key} | sh
  - aws --version
  script:
    - gitlab-terraform apply
  resource_group: ${TF_STATE_NAME}
  artifacts: 
    name: ip-list
    paths:
      - ${TF_ROOT}/public_ips.txt
    expire_in: 1 day
  when: manual
  
destroy:
  stage: destroy
  before_script:
  - cd ${TF_ROOT}
  - apk update && apk --no-cache add py3-pip && apk --no-cache add zip
  - pip install awscli
  - aws configure set default.region ${TF_VAR_aws_region} && aws configure set aws_access_key_id ${TF_VAR_aws_access_key} && aws configure set aws_secret_access_key ${TF_VAR_aws_sec_key} | sh
  script:
    - gitlab-terraform destroy
  resource_group: ${TF_STATE_NAME}
  dependencies:
    - apply
  when: manual 

